{
  This file was automatically generated on 2022-05-11.

  Delphi/Lazarus Bindings Version 2.1.32

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletDCV2;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_DC_V2_DEVICE_IDENTIFIER = 2165;
  BRICKLET_DC_V2_DEVICE_DISPLAY_NAME = 'DC Bricklet 2.0';

  BRICKLET_DC_V2_FUNCTION_SET_ENABLED = 1;
  BRICKLET_DC_V2_FUNCTION_GET_ENABLED = 2;
  BRICKLET_DC_V2_FUNCTION_SET_VELOCITY = 3;
  BRICKLET_DC_V2_FUNCTION_GET_VELOCITY = 4;
  BRICKLET_DC_V2_FUNCTION_GET_CURRENT_VELOCITY = 5;
  BRICKLET_DC_V2_FUNCTION_SET_MOTION = 6;
  BRICKLET_DC_V2_FUNCTION_GET_MOTION = 7;
  BRICKLET_DC_V2_FUNCTION_FULL_BRAKE = 8;
  BRICKLET_DC_V2_FUNCTION_SET_DRIVE_MODE = 9;
  BRICKLET_DC_V2_FUNCTION_GET_DRIVE_MODE = 10;
  BRICKLET_DC_V2_FUNCTION_SET_PWM_FREQUENCY = 11;
  BRICKLET_DC_V2_FUNCTION_GET_PWM_FREQUENCY = 12;
  BRICKLET_DC_V2_FUNCTION_GET_POWER_STATISTICS = 13;
  BRICKLET_DC_V2_FUNCTION_SET_ERROR_LED_CONFIG = 14;
  BRICKLET_DC_V2_FUNCTION_GET_ERROR_LED_CONFIG = 15;
  BRICKLET_DC_V2_FUNCTION_SET_EMERGENCY_SHUTDOWN_CALLBACK_CONFIGURATION = 16;
  BRICKLET_DC_V2_FUNCTION_GET_EMERGENCY_SHUTDOWN_CALLBACK_CONFIGURATION = 17;
  BRICKLET_DC_V2_FUNCTION_SET_VELOCITY_REACHED_CALLBACK_CONFIGURATION = 18;
  BRICKLET_DC_V2_FUNCTION_GET_VELOCITY_REACHED_CALLBACK_CONFIGURATION = 19;
  BRICKLET_DC_V2_FUNCTION_SET_CURRENT_VELOCITY_CALLBACK_CONFIGURATION = 20;
  BRICKLET_DC_V2_FUNCTION_GET_CURRENT_VELOCITY_CALLBACK_CONFIGURATION = 21;
  BRICKLET_DC_V2_FUNCTION_GET_SPITFP_ERROR_COUNT = 234;
  BRICKLET_DC_V2_FUNCTION_SET_BOOTLOADER_MODE = 235;
  BRICKLET_DC_V2_FUNCTION_GET_BOOTLOADER_MODE = 236;
  BRICKLET_DC_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237;
  BRICKLET_DC_V2_FUNCTION_WRITE_FIRMWARE = 238;
  BRICKLET_DC_V2_FUNCTION_SET_STATUS_LED_CONFIG = 239;
  BRICKLET_DC_V2_FUNCTION_GET_STATUS_LED_CONFIG = 240;
  BRICKLET_DC_V2_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICKLET_DC_V2_FUNCTION_RESET = 243;
  BRICKLET_DC_V2_FUNCTION_WRITE_UID = 248;
  BRICKLET_DC_V2_FUNCTION_READ_UID = 249;
  BRICKLET_DC_V2_FUNCTION_GET_IDENTITY = 255;

  BRICKLET_DC_V2_CALLBACK_EMERGENCY_SHUTDOWN = 22;
  BRICKLET_DC_V2_CALLBACK_VELOCITY_REACHED = 23;
  BRICKLET_DC_V2_CALLBACK_CURRENT_VELOCITY = 24;

  BRICKLET_DC_V2_DRIVE_MODE_DRIVE_BRAKE = 0;
  BRICKLET_DC_V2_DRIVE_MODE_DRIVE_COAST = 1;
  BRICKLET_DC_V2_ERROR_LED_CONFIG_OFF = 0;
  BRICKLET_DC_V2_ERROR_LED_CONFIG_ON = 1;
  BRICKLET_DC_V2_ERROR_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_DC_V2_ERROR_LED_CONFIG_SHOW_ERROR = 3;
  BRICKLET_DC_V2_BOOTLOADER_MODE_BOOTLOADER = 0;
  BRICKLET_DC_V2_BOOTLOADER_MODE_FIRMWARE = 1;
  BRICKLET_DC_V2_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
  BRICKLET_DC_V2_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
  BRICKLET_DC_V2_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
  BRICKLET_DC_V2_BOOTLOADER_STATUS_OK = 0;
  BRICKLET_DC_V2_BOOTLOADER_STATUS_INVALID_MODE = 1;
  BRICKLET_DC_V2_BOOTLOADER_STATUS_NO_CHANGE = 2;
  BRICKLET_DC_V2_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
  BRICKLET_DC_V2_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
  BRICKLET_DC_V2_BOOTLOADER_STATUS_CRC_MISMATCH = 5;
  BRICKLET_DC_V2_STATUS_LED_CONFIG_OFF = 0;
  BRICKLET_DC_V2_STATUS_LED_CONFIG_ON = 1;
  BRICKLET_DC_V2_STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_DC_V2_STATUS_LED_CONFIG_SHOW_STATUS = 3;

type
  TArray0To2OfUInt8 = array [0..2] of byte;
  TArray0To63OfUInt8 = array [0..63] of byte;

  TBrickletDCV2 = class;
  TBrickletDCV2NotifyEmergencyShutdown = procedure(sender: TBrickletDCV2) of object;
  TBrickletDCV2NotifyVelocityReached = procedure(sender: TBrickletDCV2; const velocity: smallint) of object;
  TBrickletDCV2NotifyCurrentVelocity = procedure(sender: TBrickletDCV2; const velocity: smallint) of object;

  /// <summary>
  ///  Drives one brushed DC motor with up to 28V and 5A (peak)
  /// </summary>
  TBrickletDCV2 = class(TDevice)
  private
    emergencyShutdownCallback: TBrickletDCV2NotifyEmergencyShutdown;
    velocityReachedCallback: TBrickletDCV2NotifyVelocityReached;
    currentVelocityCallback: TBrickletDCV2NotifyCurrentVelocity;
  protected
    procedure CallbackWrapperEmergencyShutdown(const packet: TByteArray); virtual;
    procedure CallbackWrapperVelocityReached(const packet: TByteArray); virtual;
    procedure CallbackWrapperCurrentVelocity(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Enables/Disables the driver chip. The driver parameters can be configured
    ///  (velocity, acceleration, etc) before it is enabled.
    /// </summary>
    procedure SetEnabled(const enabled: boolean); virtual;

    /// <summary>
    ///  Returns *true* if the driver chip is enabled, *false* otherwise.
    /// </summary>
    function GetEnabled: boolean; virtual;

    /// <summary>
    ///  Sets the velocity of the motor. Whereas -32767 is full speed backward,
    ///  0 is stop and 32767 is full speed forward. Depending on the
    ///  acceleration (see <see cref="BrickletDCV2.TBrickletDCV2.SetMotion"/>), the motor is not immediately
    ///  brought to the velocity but smoothly accelerated.
    ///  
    ///  The velocity describes the duty cycle of the PWM with which the motor is
    ///  controlled, e.g. a velocity of 3277 sets a PWM with a 10% duty cycle.
    ///  You can not only control the duty cycle of the PWM but also the frequency,
    ///  see <see cref="BrickletDCV2.TBrickletDCV2.SetPWMFrequency"/>.
    /// </summary>
    procedure SetVelocity(const velocity: smallint); virtual;

    /// <summary>
    ///  Returns the velocity as set by <see cref="BrickletDCV2.TBrickletDCV2.SetVelocity"/>.
    /// </summary>
    function GetVelocity: smallint; virtual;

    /// <summary>
    ///  Returns the *current* velocity of the motor. This value is different
    ///  from <see cref="BrickletDCV2.TBrickletDCV2.GetVelocity"/> whenever the motor is currently accelerating
    ///  to a goal set by <see cref="BrickletDCV2.TBrickletDCV2.SetVelocity"/>.
    /// </summary>
    function GetCurrentVelocity: smallint; virtual;

    /// <summary>
    ///  Sets the acceleration and deceleration of the motor. It is given in *velocity/s*.
    ///  An acceleration of 10000 means, that every second the velocity is increased
    ///  by 10000 (or about 30% duty cycle).
    ///  
    ///  For example: If the current velocity is 0 and you want to accelerate to a
    ///  velocity of 16000 (about 50% duty cycle) in 10 seconds, you should set
    ///  an acceleration of 1600.
    ///  
    ///  If acceleration and deceleration is set to 0, there is no speed ramping, i.e. a
    ///  new velocity is immediately given to the motor.
    /// </summary>
    procedure SetMotion(const acceleration: word; const deceleration: word); virtual;

    /// <summary>
    ///  Returns the acceleration/deceleration as set by <see cref="BrickletDCV2.TBrickletDCV2.SetMotion"/>.
    /// </summary>
    procedure GetMotion(out acceleration: word; out deceleration: word); virtual;

    /// <summary>
    ///  Executes an active full brake.
    ///  
    ///  <note type="caution">
    ///   This function is for emergency purposes,
    ///   where an immediate brake is necessary. Depending on the current velocity and
    ///   the strength of the motor, a full brake can be quite violent.
    ///  </note>
    ///  
    ///  Call <see cref="BrickletDCV2.TBrickletDCV2.SetVelocity"/> with 0 if you just want to stop the motor.
    /// </summary>
    procedure FullBrake; virtual;

    /// <summary>
    ///  Sets the drive mode. Possible modes are:
    ///  
    ///  * 0 = Drive/Brake
    ///  * 1 = Drive/Coast
    ///  
    ///  These modes are different kinds of motor controls.
    ///  
    ///  In Drive/Brake mode, the motor is always either driving or braking. There
    ///  is no freewheeling. Advantages are: A more linear correlation between
    ///  PWM and velocity, more exact accelerations and the possibility to drive
    ///  with slower velocities.
    ///  
    ///  In Drive/Coast mode, the motor is always either driving or freewheeling.
    ///  Advantages are: Less current consumption and less demands on the motor and
    ///  driver chip.
    /// </summary>
    procedure SetDriveMode(const mode: byte); virtual;

    /// <summary>
    ///  Returns the drive mode, as set by <see cref="BrickletDCV2.TBrickletDCV2.SetDriveMode"/>.
    /// </summary>
    function GetDriveMode: byte; virtual;

    /// <summary>
    ///  Sets the frequency of the PWM with which the motor is driven.
    ///  Often a high frequency
    ///  is less noisy and the motor runs smoother. However, with a low frequency
    ///  there are less switches and therefore fewer switching losses. Also with
    ///  most motors lower frequencies enable higher torque.
    ///  
    ///  If you have no idea what all this means, just ignore this function and use
    ///  the default frequency, it will very likely work fine.
    /// </summary>
    procedure SetPWMFrequency(const frequency: word); virtual;

    /// <summary>
    ///  Returns the PWM frequency as set by <see cref="BrickletDCV2.TBrickletDCV2.SetPWMFrequency"/>.
    /// </summary>
    function GetPWMFrequency: word; virtual;

    /// <summary>
    ///  Returns input voltage and current usage of the driver.
    /// </summary>
    procedure GetPowerStatistics(out voltage: word; out current: word); virtual;

    /// <summary>
    ///  Configures the error LED to be either turned off, turned on, blink in
    ///  heartbeat mode or show an error.
    ///  
    ///  If the LED is configured to show errors it has three different states:
    ///  
    ///  * Off: No error present.
    ///  * 1s interval blinking: Input voltage too low (below 6V).
    ///  * 250ms interval blinking: Overtemperature or overcurrent.
    /// </summary>
    procedure SetErrorLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the LED configuration as set by <see cref="BrickletDCV2.TBrickletDCV2.SetErrorLEDConfig"/>
    /// </summary>
    function GetErrorLEDConfig: byte; virtual;

    /// <summary>
    ///  Enable/Disable <see cref="BrickletDCV2.TBrickletDCV2.OnEmergencyShutdown"/> callback.
    /// </summary>
    procedure SetEmergencyShutdownCallbackConfiguration(const enabled: boolean); virtual;

    /// <summary>
    ///  Returns the callback configuration as set by
    ///  <see cref="BrickletDCV2.TBrickletDCV2.SetEmergencyShutdownCallbackConfiguration"/>.
    /// </summary>
    function GetEmergencyShutdownCallbackConfiguration: boolean; virtual;

    /// <summary>
    ///  Enable/Disable <see cref="BrickletDCV2.TBrickletDCV2.OnVelocityReached"/> callback.
    /// </summary>
    procedure SetVelocityReachedCallbackConfiguration(const enabled: boolean); virtual;

    /// <summary>
    ///  Returns the callback configuration as set by
    ///  <see cref="BrickletDCV2.TBrickletDCV2.SetVelocityReachedCallbackConfiguration"/>.
    /// </summary>
    function GetVelocityReachedCallbackConfiguration: boolean; virtual;

    /// <summary>
    ///  The period is the period with which the <see cref="BrickletDCV2.TBrickletDCV2.OnCurrentVelocity"/>
    ///  callback is triggered periodically. A value of 0 turns the callback off.
    ///  
    ///  If the `value has to change`-parameter is set to true, the callback is only
    ///  triggered after the value has changed. If the value didn't change within the
    ///  period, the callback is triggered immediately on change.
    ///  
    ///  If it is set to false, the callback is continuously triggered with the period,
    ///  independent of the value.
    /// </summary>
    procedure SetCurrentVelocityCallbackConfiguration(const period: longword; const valueHasToChange: boolean); virtual;

    /// <summary>
    ///  Returns the callback configuration as set by
    ///  <see cref="BrickletDCV2.TBrickletDCV2.SetCurrentVelocityCallbackConfiguration"/>.
    /// </summary>
    procedure GetCurrentVelocityCallbackConfiguration(out period: longword; out valueHasToChange: boolean); virtual;

    /// <summary>
    ///  Returns the error count for the communication between Brick and Bricklet.
    ///  
    ///  The errors are divided into
    ///  
    ///  * ACK checksum errors,
    ///  * message checksum errors,
    ///  * framing errors and
    ///  * overflow errors.
    ///  
    ///  The errors counts are for errors that occur on the Bricklet side. All
    ///  Bricks have a similar function that returns the errors on the Brick side.
    /// </summary>
    procedure GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword); virtual;

    /// <summary>
    ///  Sets the bootloader mode and returns the status after the requested
    ///  mode change was instigated.
    ///  
    ///  You can change from bootloader mode to firmware mode and vice versa. A change
    ///  from bootloader mode to firmware mode will only take place if the entry function,
    ///  device identifier and CRC are present and correct.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function SetBootloaderMode(const mode: byte): byte; virtual;

    /// <summary>
    ///  Returns the current bootloader mode, see <see cref="BrickletDCV2.TBrickletDCV2.SetBootloaderMode"/>.
    /// </summary>
    function GetBootloaderMode: byte; virtual;

    /// <summary>
    ///  Sets the firmware pointer for <see cref="BrickletDCV2.TBrickletDCV2.WriteFirmware"/>. The pointer has
    ///  to be increased by chunks of size 64. The data is written to flash
    ///  every 4 chunks (which equals to one page of size 256).
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    procedure SetWriteFirmwarePointer(const pointer: longword); virtual;

    /// <summary>
    ///  Writes 64 Bytes of firmware at the position as written by
    ///  <see cref="BrickletDCV2.TBrickletDCV2.SetWriteFirmwarePointer"/> before. The firmware is written
    ///  to flash every 4 chunks.
    ///  
    ///  You can only write firmware in bootloader mode.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function WriteFirmware(const data: array of byte): byte; virtual;

    /// <summary>
    ///  Sets the status LED configuration. By default the LED shows
    ///  communication traffic between Brick and Bricklet, it flickers once
    ///  for every 10 received data packets.
    ///  
    ///  You can also turn the LED permanently on/off or show a heartbeat.
    ///  
    ///  If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    /// </summary>
    procedure SetStatusLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletDCV2.TBrickletDCV2.SetStatusLEDConfig"/>
    /// </summary>
    function GetStatusLEDConfig: byte; virtual;

    /// <summary>
    ///  Returns the temperature as measured inside the microcontroller. The
    ///  value returned is not the ambient temperature!
    ///  
    ///  The temperature is only proportional to the real temperature and it has bad
    ///  accuracy. Practically it is only useful as an indicator for
    ///  temperature changes.
    /// </summary>
    function GetChipTemperature: smallint; virtual;

    /// <summary>
    ///  Calling this function will reset the Bricklet. All configurations
    ///  will be lost.
    ///  
    ///  After a reset you have to create new device objects,
    ///  calling functions on the existing ones will result in
    ///  undefined behavior!
    /// </summary>
    procedure Reset; virtual;

    /// <summary>
    ///  Writes a new UID into flash. If you want to set a new UID
    ///  you have to decode the Base58 encoded UID string into an
    ///  integer first.
    ///  
    ///  We recommend that you use Brick Viewer to change the UID.
    /// </summary>
    procedure WriteUID(const uid: longword); virtual;

    /// <summary>
    ///  Returns the current UID as an integer. Encode as
    ///  Base58 to get the usual string version.
    /// </summary>
    function ReadUID: longword; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    ///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
    ///  position 'z'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;

    /// <summary>
    ///  This callback is triggered if either the current consumption
    ///  is too high (above 5A) or the temperature of the driver chip is too high
    ///  (above 175°C). These two possibilities are essentially the same, since the
    ///  temperature will reach this threshold immediately if the motor consumes too
    ///  much current. In case of a voltage below 3.3V (external or stack) this
    ///  callback is triggered as well.
    ///  
    ///  If this callback is triggered, the driver chip gets disabled at the same time.
    ///  That means, <see cref="BrickletDCV2.TBrickletDCV2.SetEnabled"/> has to be called to drive the motor again.
    ///  
    ///  <note>
    ///   This callback only works in Drive/Brake mode (see <see cref="BrickletDCV2.TBrickletDCV2.SetDriveMode"/>). In
    ///   Drive/Coast mode it is unfortunately impossible to reliably read the
    ///   overcurrent/overtemperature signal from the driver chip.
    ///  </note>
    /// </summary>
    property OnEmergencyShutdown: TBrickletDCV2NotifyEmergencyShutdown read emergencyShutdownCallback write emergencyShutdownCallback;

    /// <summary>
    ///  This callback is triggered whenever a set velocity is reached. For example:
    ///  If a velocity of 0 is present, acceleration is set to 5000 and velocity
    ///  to 10000, the <see cref="BrickletDCV2.TBrickletDCV2.OnVelocityReached"/> callback will be triggered after about
    ///  2 seconds, when the set velocity is actually reached.
    ///  
    ///  <note>
    ///   Since we can't get any feedback from the DC motor, this only works if the
    ///   acceleration (see <see cref="BrickletDCV2.TBrickletDCV2.SetMotion"/>) is set smaller or equal to the
    ///   maximum acceleration of the motor. Otherwise the motor will lag behind the
    ///   control value and the callback will be triggered too early.
    ///  </note>
    /// </summary>
    property OnVelocityReached: TBrickletDCV2NotifyVelocityReached read velocityReachedCallback write velocityReachedCallback;

    /// <summary>
    ///  This callback is triggered with the period that is set by
    ///  <see cref="BrickletDCV2.TBrickletDCV2.SetCurrentVelocityCallbackConfiguration"/>. The parameter is the *current*
    ///  velocity used by the motor.
    ///  
    ///  The <see cref="BrickletDCV2.TBrickletDCV2.OnCurrentVelocity"/> callback is only triggered after the set period
    ///  if there is a change in the velocity.
    /// </summary>
    property OnCurrentVelocity: TBrickletDCV2NotifyCurrentVelocity read currentVelocityCallback write currentVelocityCallback;
  end;

implementation

constructor TBrickletDCV2.Create(const uid: string; ipcon_: TIPConnection);
begin
  inherited Create(uid, ipcon_, BRICKLET_DC_V2_DEVICE_IDENTIFIER, BRICKLET_DC_V2_DEVICE_DISPLAY_NAME);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 0;

  responseExpected[BRICKLET_DC_V2_FUNCTION_SET_ENABLED] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_GET_ENABLED] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_SET_VELOCITY] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_GET_VELOCITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_GET_CURRENT_VELOCITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_SET_MOTION] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_GET_MOTION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_FULL_BRAKE] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_SET_DRIVE_MODE] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_GET_DRIVE_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_SET_PWM_FREQUENCY] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_GET_PWM_FREQUENCY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_GET_POWER_STATISTICS] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_SET_ERROR_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_GET_ERROR_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_SET_EMERGENCY_SHUTDOWN_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_GET_EMERGENCY_SHUTDOWN_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_SET_VELOCITY_REACHED_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_GET_VELOCITY_REACHED_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_SET_CURRENT_VELOCITY_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_GET_CURRENT_VELOCITY_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_GET_SPITFP_ERROR_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_SET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_GET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_WRITE_FIRMWARE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_SET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_GET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_GET_CHIP_TEMPERATURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_RESET] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_WRITE_UID] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_READ_UID] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DC_V2_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  callbackWrappers[BRICKLET_DC_V2_CALLBACK_EMERGENCY_SHUTDOWN] := {$ifdef FPC}@{$endif}CallbackWrapperEmergencyShutdown;
  callbackWrappers[BRICKLET_DC_V2_CALLBACK_VELOCITY_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperVelocityReached;
  callbackWrappers[BRICKLET_DC_V2_CALLBACK_CURRENT_VELOCITY] := {$ifdef FPC}@{$endif}CallbackWrapperCurrentVelocity;

  (ipcon as TIPConnection).AddDevice(self);
end;

procedure TBrickletDCV2.SetEnabled(const enabled: boolean);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_SET_ENABLED, 9);
  LEConvertBooleanTo(enabled, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDCV2.GetEnabled: boolean;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_GET_ENABLED, 8);
  response := SendRequest(request, 9);
  result := LEConvertBooleanFrom(8, response);
end;

procedure TBrickletDCV2.SetVelocity(const velocity: smallint);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_SET_VELOCITY, 10);
  LEConvertInt16To(velocity, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDCV2.GetVelocity: smallint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_GET_VELOCITY, 8);
  response := SendRequest(request, 10);
  result := LEConvertInt16From(8, response);
end;

function TBrickletDCV2.GetCurrentVelocity: smallint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_GET_CURRENT_VELOCITY, 8);
  response := SendRequest(request, 10);
  result := LEConvertInt16From(8, response);
end;

procedure TBrickletDCV2.SetMotion(const acceleration: word; const deceleration: word);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_SET_MOTION, 12);
  LEConvertUInt16To(acceleration, 8, request);
  LEConvertUInt16To(deceleration, 10, request);
  SendRequest(request, 0);
end;

procedure TBrickletDCV2.GetMotion(out acceleration: word; out deceleration: word);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_GET_MOTION, 8);
  response := SendRequest(request, 12);
  acceleration := LEConvertUInt16From(8, response);
  deceleration := LEConvertUInt16From(10, response);
end;

procedure TBrickletDCV2.FullBrake;
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_FULL_BRAKE, 8);
  SendRequest(request, 0);
end;

procedure TBrickletDCV2.SetDriveMode(const mode: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_SET_DRIVE_MODE, 9);
  LEConvertUInt8To(mode, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDCV2.GetDriveMode: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_GET_DRIVE_MODE, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletDCV2.SetPWMFrequency(const frequency: word);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_SET_PWM_FREQUENCY, 10);
  LEConvertUInt16To(frequency, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDCV2.GetPWMFrequency: word;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_GET_PWM_FREQUENCY, 8);
  response := SendRequest(request, 10);
  result := LEConvertUInt16From(8, response);
end;

procedure TBrickletDCV2.GetPowerStatistics(out voltage: word; out current: word);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_GET_POWER_STATISTICS, 8);
  response := SendRequest(request, 12);
  voltage := LEConvertUInt16From(8, response);
  current := LEConvertUInt16From(10, response);
end;

procedure TBrickletDCV2.SetErrorLEDConfig(const config: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_SET_ERROR_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDCV2.GetErrorLEDConfig: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_GET_ERROR_LED_CONFIG, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletDCV2.SetEmergencyShutdownCallbackConfiguration(const enabled: boolean);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_SET_EMERGENCY_SHUTDOWN_CALLBACK_CONFIGURATION, 9);
  LEConvertBooleanTo(enabled, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDCV2.GetEmergencyShutdownCallbackConfiguration: boolean;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_GET_EMERGENCY_SHUTDOWN_CALLBACK_CONFIGURATION, 8);
  response := SendRequest(request, 9);
  result := LEConvertBooleanFrom(8, response);
end;

procedure TBrickletDCV2.SetVelocityReachedCallbackConfiguration(const enabled: boolean);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_SET_VELOCITY_REACHED_CALLBACK_CONFIGURATION, 9);
  LEConvertBooleanTo(enabled, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDCV2.GetVelocityReachedCallbackConfiguration: boolean;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_GET_VELOCITY_REACHED_CALLBACK_CONFIGURATION, 8);
  response := SendRequest(request, 9);
  result := LEConvertBooleanFrom(8, response);
end;

procedure TBrickletDCV2.SetCurrentVelocityCallbackConfiguration(const period: longword; const valueHasToChange: boolean);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_SET_CURRENT_VELOCITY_CALLBACK_CONFIGURATION, 13);
  LEConvertUInt32To(period, 8, request);
  LEConvertBooleanTo(valueHasToChange, 12, request);
  SendRequest(request, 0);
end;

procedure TBrickletDCV2.GetCurrentVelocityCallbackConfiguration(out period: longword; out valueHasToChange: boolean);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_GET_CURRENT_VELOCITY_CALLBACK_CONFIGURATION, 8);
  response := SendRequest(request, 13);
  period := LEConvertUInt32From(8, response);
  valueHasToChange := LEConvertBooleanFrom(12, response);
end;

procedure TBrickletDCV2.GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_GET_SPITFP_ERROR_COUNT, 8);
  response := SendRequest(request, 24);
  errorCountAckChecksum := LEConvertUInt32From(8, response);
  errorCountMessageChecksum := LEConvertUInt32From(12, response);
  errorCountFrame := LEConvertUInt32From(16, response);
  errorCountOverflow := LEConvertUInt32From(20, response);
end;

function TBrickletDCV2.SetBootloaderMode(const mode: byte): byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_SET_BOOTLOADER_MODE, 9);
  LEConvertUInt8To(mode, 8, request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletDCV2.GetBootloaderMode: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_GET_BOOTLOADER_MODE, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletDCV2.SetWriteFirmwarePointer(const pointer: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER, 12);
  LEConvertUInt32To(pointer, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDCV2.WriteFirmware(const data: array of byte): byte;
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_WRITE_FIRMWARE, 72);
  if (Length(data) <> 64) then raise EInvalidParameterException.Create('Data has to be exactly 64 items long');
  for i := 0 to Length(data) - 1 do LEConvertUInt8To(data[i], 8 + (i * 1), request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletDCV2.SetStatusLEDConfig(const config: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_SET_STATUS_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDCV2.GetStatusLEDConfig: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_GET_STATUS_LED_CONFIG, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletDCV2.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_GET_CHIP_TEMPERATURE, 8);
  response := SendRequest(request, 10);
  result := LEConvertInt16From(8, response);
end;

procedure TBrickletDCV2.Reset;
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_RESET, 8);
  SendRequest(request, 0);
end;

procedure TBrickletDCV2.WriteUID(const uid: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_WRITE_UID, 12);
  LEConvertUInt32To(uid, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDCV2.ReadUID: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_READ_UID, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletDCV2.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DC_V2_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request, 33);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

procedure TBrickletDCV2.CallbackWrapperEmergencyShutdown(const packet: TByteArray);
begin
  if (Length(packet) <> 8) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  if (Assigned(emergencyShutdownCallback)) then begin
    emergencyShutdownCallback(self);
  end;
end;

procedure TBrickletDCV2.CallbackWrapperVelocityReached(const packet: TByteArray);
var velocity: smallint;
begin
  if (Length(packet) <> 10) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  velocity := LEConvertInt16From(8, packet);
  if (Assigned(velocityReachedCallback)) then begin
    velocityReachedCallback(self, velocity);
  end;
end;

procedure TBrickletDCV2.CallbackWrapperCurrentVelocity(const packet: TByteArray);
var velocity: smallint;
begin
  if (Length(packet) <> 10) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  velocity := LEConvertInt16From(8, packet);
  if (Assigned(currentVelocityCallback)) then begin
    currentVelocityCallback(self, velocity);
  end;
end;

end.
