{
  This file was automatically generated on 2022-05-11.

  Delphi/Lazarus Bindings Version 2.1.32

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletDistanceIRV2;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_DISTANCE_IR_V2_DEVICE_IDENTIFIER = 2125;
  BRICKLET_DISTANCE_IR_V2_DEVICE_DISPLAY_NAME = 'Distance IR Bricklet 2.0';

  BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_DISTANCE = 1;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_DISTANCE_CALLBACK_CONFIGURATION = 2;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_DISTANCE_CALLBACK_CONFIGURATION = 3;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_ANALOG_VALUE = 5;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_ANALOG_VALUE_CALLBACK_CONFIGURATION = 6;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_ANALOG_VALUE_CALLBACK_CONFIGURATION = 7;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_MOVING_AVERAGE_CONFIGURATION = 9;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_MOVING_AVERAGE_CONFIGURATION = 10;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_DISTANCE_LED_CONFIG = 11;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_DISTANCE_LED_CONFIG = 12;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_SENSOR_TYPE = 13;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_SENSOR_TYPE = 14;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_SPITFP_ERROR_COUNT = 234;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_BOOTLOADER_MODE = 235;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_BOOTLOADER_MODE = 236;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_WRITE_FIRMWARE = 238;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_STATUS_LED_CONFIG = 239;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_STATUS_LED_CONFIG = 240;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_RESET = 243;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_WRITE_UID = 248;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_READ_UID = 249;
  BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_IDENTITY = 255;

  BRICKLET_DISTANCE_IR_V2_CALLBACK_DISTANCE = 4;
  BRICKLET_DISTANCE_IR_V2_CALLBACK_ANALOG_VALUE = 8;

  BRICKLET_DISTANCE_IR_V2_THRESHOLD_OPTION_OFF = 'x';
  BRICKLET_DISTANCE_IR_V2_THRESHOLD_OPTION_OUTSIDE = 'o';
  BRICKLET_DISTANCE_IR_V2_THRESHOLD_OPTION_INSIDE = 'i';
  BRICKLET_DISTANCE_IR_V2_THRESHOLD_OPTION_SMALLER = '<';
  BRICKLET_DISTANCE_IR_V2_THRESHOLD_OPTION_GREATER = '>';
  BRICKLET_DISTANCE_IR_V2_DISTANCE_LED_CONFIG_OFF = 0;
  BRICKLET_DISTANCE_IR_V2_DISTANCE_LED_CONFIG_ON = 1;
  BRICKLET_DISTANCE_IR_V2_DISTANCE_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_DISTANCE_IR_V2_DISTANCE_LED_CONFIG_SHOW_DISTANCE = 3;
  BRICKLET_DISTANCE_IR_V2_SENSOR_TYPE_2Y0A41 = 0;
  BRICKLET_DISTANCE_IR_V2_SENSOR_TYPE_2Y0A21 = 1;
  BRICKLET_DISTANCE_IR_V2_SENSOR_TYPE_2Y0A02 = 2;
  BRICKLET_DISTANCE_IR_V2_BOOTLOADER_MODE_BOOTLOADER = 0;
  BRICKLET_DISTANCE_IR_V2_BOOTLOADER_MODE_FIRMWARE = 1;
  BRICKLET_DISTANCE_IR_V2_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
  BRICKLET_DISTANCE_IR_V2_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
  BRICKLET_DISTANCE_IR_V2_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
  BRICKLET_DISTANCE_IR_V2_BOOTLOADER_STATUS_OK = 0;
  BRICKLET_DISTANCE_IR_V2_BOOTLOADER_STATUS_INVALID_MODE = 1;
  BRICKLET_DISTANCE_IR_V2_BOOTLOADER_STATUS_NO_CHANGE = 2;
  BRICKLET_DISTANCE_IR_V2_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
  BRICKLET_DISTANCE_IR_V2_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
  BRICKLET_DISTANCE_IR_V2_BOOTLOADER_STATUS_CRC_MISMATCH = 5;
  BRICKLET_DISTANCE_IR_V2_STATUS_LED_CONFIG_OFF = 0;
  BRICKLET_DISTANCE_IR_V2_STATUS_LED_CONFIG_ON = 1;
  BRICKLET_DISTANCE_IR_V2_STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_DISTANCE_IR_V2_STATUS_LED_CONFIG_SHOW_STATUS = 3;

type
  TArray0To2OfUInt8 = array [0..2] of byte;
  TArray0To63OfUInt8 = array [0..63] of byte;

  TBrickletDistanceIRV2 = class;
  TBrickletDistanceIRV2NotifyDistance = procedure(sender: TBrickletDistanceIRV2; const distance: word) of object;
  TBrickletDistanceIRV2NotifyAnalogValue = procedure(sender: TBrickletDistanceIRV2; const analogValue: longword) of object;

  /// <summary>
  ///  Measures distance up to 150cm with infrared light
  /// </summary>
  TBrickletDistanceIRV2 = class(TDevice)
  private
    distanceCallback: TBrickletDistanceIRV2NotifyDistance;
    analogValueCallback: TBrickletDistanceIRV2NotifyAnalogValue;
  protected
    procedure CallbackWrapperDistance(const packet: TByteArray); virtual;
    procedure CallbackWrapperAnalogValue(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Returns the distance measured by the sensor. Possible
    ///  distance ranges are 40 to 300, 100 to 800 and 200 to 1500, depending on the
    ///  selected IR sensor.
    ///  
    ///  
    ///  If you want to get the value periodically, it is recommended to use the
    ///  <see cref="BrickletDistanceIRV2.TBrickletDistanceIRV2.OnDistance"/> callback. You can set the callback configuration
    ///  with <see cref="BrickletDistanceIRV2.TBrickletDistanceIRV2.SetDistanceCallbackConfiguration"/>.
    /// </summary>
    function GetDistance: word; virtual;

    /// <summary>
    ///  The period is the period with which the <see cref="BrickletDistanceIRV2.TBrickletDistanceIRV2.OnDistance"/> callback is triggered
    ///  periodically. A value of 0 turns the callback off.
    ///  
    ///  If the `value has to change`-parameter is set to true, the callback is only
    ///  triggered after the value has changed. If the value didn't change
    ///  within the period, the callback is triggered immediately on change.
    ///  
    ///  If it is set to false, the callback is continuously triggered with the period,
    ///  independent of the value.
    ///  
    ///  It is furthermore possible to constrain the callback with thresholds.
    ///  
    ///  The `option`-parameter together with min/max sets a threshold for the <see cref="BrickletDistanceIRV2.TBrickletDistanceIRV2.OnDistance"/> callback.
    ///  
    ///  The following options are possible:
    ///  
    ///  <code>
    ///   "Option", "Description"
    ///  
    ///   "'x'",    "Threshold is turned off"
    ///   "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    ///   "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    ///   "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    ///   "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    ///  </code>
    ///  
    ///  If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    /// </summary>
    procedure SetDistanceCallbackConfiguration(const period: longword; const valueHasToChange: boolean; const option: char; const min: word; const max: word); virtual;

    /// <summary>
    ///  Returns the callback configuration as set by <see cref="BrickletDistanceIRV2.TBrickletDistanceIRV2.SetDistanceCallbackConfiguration"/>.
    /// </summary>
    procedure GetDistanceCallbackConfiguration(out period: longword; out valueHasToChange: boolean; out option: char; out min: word; out max: word); virtual;

    /// <summary>
    ///  Returns the analog value as read by a analog-to-digital converter.
    ///  
    ///  This is unfiltered raw data. We made sure that the integration time
    ///  of the ADC is shorter then the measurement interval of the sensor
    ///  (10ms vs 16.5ms). So there is no information lost.
    ///  
    ///  If you want to do your own calibration or create your own lookup table
    ///  you can use this value.
    ///  
    ///  
    ///  If you want to get the value periodically, it is recommended to use the
    ///  <see cref="BrickletDistanceIRV2.TBrickletDistanceIRV2.OnAnalogValue"/> callback. You can set the callback configuration
    ///  with <see cref="BrickletDistanceIRV2.TBrickletDistanceIRV2.SetAnalogValueCallbackConfiguration"/>.
    /// </summary>
    function GetAnalogValue: longword; virtual;

    /// <summary>
    ///  The period is the period with which the <see cref="BrickletDistanceIRV2.TBrickletDistanceIRV2.OnAnalogValue"/> callback is triggered
    ///  periodically. A value of 0 turns the callback off.
    ///  
    ///  If the `value has to change`-parameter is set to true, the callback is only
    ///  triggered after the value has changed. If the value didn't change
    ///  within the period, the callback is triggered immediately on change.
    ///  
    ///  If it is set to false, the callback is continuously triggered with the period,
    ///  independent of the value.
    ///  
    ///  It is furthermore possible to constrain the callback with thresholds.
    ///  
    ///  The `option`-parameter together with min/max sets a threshold for the <see cref="BrickletDistanceIRV2.TBrickletDistanceIRV2.OnAnalogValue"/> callback.
    ///  
    ///  The following options are possible:
    ///  
    ///  <code>
    ///   "Option", "Description"
    ///  
    ///   "'x'",    "Threshold is turned off"
    ///   "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    ///   "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    ///   "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    ///   "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    ///  </code>
    ///  
    ///  If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    /// </summary>
    procedure SetAnalogValueCallbackConfiguration(const period: longword; const valueHasToChange: boolean; const option: char; const min: longword; const max: longword); virtual;

    /// <summary>
    ///  Returns the callback configuration as set by <see cref="BrickletDistanceIRV2.TBrickletDistanceIRV2.SetAnalogValueCallbackConfiguration"/>.
    /// </summary>
    procedure GetAnalogValueCallbackConfiguration(out period: longword; out valueHasToChange: boolean; out option: char; out min: longword; out max: longword); virtual;

    /// <summary>
    ///  Sets the length of a `moving averaging &lt;https://en.wikipedia.org/wiki/Moving_average&gt;`__
    ///  for the distance.
    ///  
    ///  Setting the length to 1 will turn the averaging off. With less averaging, there
    ///  is more noise on the data.
    ///  
    ///  New data is gathered every ~10ms. With a moving average of length 1000 the
    ///  resulting averaging window has a length of approximately 10s. If you want to do
    ///  long term measurements the longest moving average will give the cleanest results.
    /// </summary>
    procedure SetMovingAverageConfiguration(const movingAverageLength: word); virtual;

    /// <summary>
    ///  Returns the moving average configuration as set by <see cref="BrickletDistanceIRV2.TBrickletDistanceIRV2.SetMovingAverageConfiguration"/>.
    /// </summary>
    function GetMovingAverageConfiguration: word; virtual;

    /// <summary>
    ///  Configures the distance LED to be either turned off, turned on, blink in
    ///  heartbeat mode or show the distance (brighter = object is nearer).
    /// </summary>
    procedure SetDistanceLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the LED configuration as set by <see cref="BrickletDistanceIRV2.TBrickletDistanceIRV2.SetDistanceLEDConfig"/>
    /// </summary>
    function GetDistanceLEDConfig: byte; virtual;

    /// <summary>
    ///  Sets the sensor type.
    ///  
    ///  The Bricklet comes configured with the correct sensor type
    ///  and the type is saved in flash (i.e. the Bricklet retains the information if
    ///  power is lost).
    ///  
    ///  If you want to change the sensor you can set the type in Brick Viewer,
    ///  you will likely never need to call this function from your program.
    /// </summary>
    procedure SetSensorType(const sensor: byte); virtual;

    /// <summary>
    ///  Returns the sensor type as set by <see cref="BrickletDistanceIRV2.TBrickletDistanceIRV2.SetSensorType"/>.
    /// </summary>
    function GetSensorType: byte; virtual;

    /// <summary>
    ///  Returns the error count for the communication between Brick and Bricklet.
    ///  
    ///  The errors are divided into
    ///  
    ///  * ACK checksum errors,
    ///  * message checksum errors,
    ///  * framing errors and
    ///  * overflow errors.
    ///  
    ///  The errors counts are for errors that occur on the Bricklet side. All
    ///  Bricks have a similar function that returns the errors on the Brick side.
    /// </summary>
    procedure GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword); virtual;

    /// <summary>
    ///  Sets the bootloader mode and returns the status after the requested
    ///  mode change was instigated.
    ///  
    ///  You can change from bootloader mode to firmware mode and vice versa. A change
    ///  from bootloader mode to firmware mode will only take place if the entry function,
    ///  device identifier and CRC are present and correct.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function SetBootloaderMode(const mode: byte): byte; virtual;

    /// <summary>
    ///  Returns the current bootloader mode, see <see cref="BrickletDistanceIRV2.TBrickletDistanceIRV2.SetBootloaderMode"/>.
    /// </summary>
    function GetBootloaderMode: byte; virtual;

    /// <summary>
    ///  Sets the firmware pointer for <see cref="BrickletDistanceIRV2.TBrickletDistanceIRV2.WriteFirmware"/>. The pointer has
    ///  to be increased by chunks of size 64. The data is written to flash
    ///  every 4 chunks (which equals to one page of size 256).
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    procedure SetWriteFirmwarePointer(const pointer: longword); virtual;

    /// <summary>
    ///  Writes 64 Bytes of firmware at the position as written by
    ///  <see cref="BrickletDistanceIRV2.TBrickletDistanceIRV2.SetWriteFirmwarePointer"/> before. The firmware is written
    ///  to flash every 4 chunks.
    ///  
    ///  You can only write firmware in bootloader mode.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function WriteFirmware(const data: array of byte): byte; virtual;

    /// <summary>
    ///  Sets the status LED configuration. By default the LED shows
    ///  communication traffic between Brick and Bricklet, it flickers once
    ///  for every 10 received data packets.
    ///  
    ///  You can also turn the LED permanently on/off or show a heartbeat.
    ///  
    ///  If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    /// </summary>
    procedure SetStatusLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletDistanceIRV2.TBrickletDistanceIRV2.SetStatusLEDConfig"/>
    /// </summary>
    function GetStatusLEDConfig: byte; virtual;

    /// <summary>
    ///  Returns the temperature as measured inside the microcontroller. The
    ///  value returned is not the ambient temperature!
    ///  
    ///  The temperature is only proportional to the real temperature and it has bad
    ///  accuracy. Practically it is only useful as an indicator for
    ///  temperature changes.
    /// </summary>
    function GetChipTemperature: smallint; virtual;

    /// <summary>
    ///  Calling this function will reset the Bricklet. All configurations
    ///  will be lost.
    ///  
    ///  After a reset you have to create new device objects,
    ///  calling functions on the existing ones will result in
    ///  undefined behavior!
    /// </summary>
    procedure Reset; virtual;

    /// <summary>
    ///  Writes a new UID into flash. If you want to set a new UID
    ///  you have to decode the Base58 encoded UID string into an
    ///  integer first.
    ///  
    ///  We recommend that you use Brick Viewer to change the UID.
    /// </summary>
    procedure WriteUID(const uid: longword); virtual;

    /// <summary>
    ///  Returns the current UID as an integer. Encode as
    ///  Base58 to get the usual string version.
    /// </summary>
    function ReadUID: longword; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    ///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
    ///  position 'z'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;

    /// <summary>
    ///  This callback is triggered periodically according to the configuration set by
    ///  <see cref="BrickletDistanceIRV2.TBrickletDistanceIRV2.SetDistanceCallbackConfiguration"/>.
    ///  
    ///  The parameter is the same as <see cref="BrickletDistanceIRV2.TBrickletDistanceIRV2.GetDistance"/>.
    /// </summary>
    property OnDistance: TBrickletDistanceIRV2NotifyDistance read distanceCallback write distanceCallback;

    /// <summary>
    ///  This callback is triggered periodically according to the configuration set by
    ///  <see cref="BrickletDistanceIRV2.TBrickletDistanceIRV2.SetAnalogValueCallbackConfiguration"/>.
    ///  
    ///  The parameter is the same as <see cref="BrickletDistanceIRV2.TBrickletDistanceIRV2.GetAnalogValue"/>.
    /// </summary>
    property OnAnalogValue: TBrickletDistanceIRV2NotifyAnalogValue read analogValueCallback write analogValueCallback;
  end;

implementation

constructor TBrickletDistanceIRV2.Create(const uid: string; ipcon_: TIPConnection);
begin
  inherited Create(uid, ipcon_, BRICKLET_DISTANCE_IR_V2_DEVICE_IDENTIFIER, BRICKLET_DISTANCE_IR_V2_DEVICE_DISPLAY_NAME);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 1;

  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_DISTANCE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_DISTANCE_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_DISTANCE_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_ANALOG_VALUE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_ANALOG_VALUE_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_ANALOG_VALUE_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_MOVING_AVERAGE_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_MOVING_AVERAGE_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_DISTANCE_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_DISTANCE_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_SENSOR_TYPE] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_SENSOR_TYPE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_SPITFP_ERROR_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_WRITE_FIRMWARE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_CHIP_TEMPERATURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_RESET] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_WRITE_UID] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_READ_UID] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  callbackWrappers[BRICKLET_DISTANCE_IR_V2_CALLBACK_DISTANCE] := {$ifdef FPC}@{$endif}CallbackWrapperDistance;
  callbackWrappers[BRICKLET_DISTANCE_IR_V2_CALLBACK_ANALOG_VALUE] := {$ifdef FPC}@{$endif}CallbackWrapperAnalogValue;

  (ipcon as TIPConnection).AddDevice(self);
end;

function TBrickletDistanceIRV2.GetDistance: word;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_DISTANCE, 8);
  response := SendRequest(request, 10);
  result := LEConvertUInt16From(8, response);
end;

procedure TBrickletDistanceIRV2.SetDistanceCallbackConfiguration(const period: longword; const valueHasToChange: boolean; const option: char; const min: word; const max: word);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_DISTANCE_CALLBACK_CONFIGURATION, 18);
  LEConvertUInt32To(period, 8, request);
  LEConvertBooleanTo(valueHasToChange, 12, request);
  LEConvertCharTo(option, 13, request);
  LEConvertUInt16To(min, 14, request);
  LEConvertUInt16To(max, 16, request);
  SendRequest(request, 0);
end;

procedure TBrickletDistanceIRV2.GetDistanceCallbackConfiguration(out period: longword; out valueHasToChange: boolean; out option: char; out min: word; out max: word);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_DISTANCE_CALLBACK_CONFIGURATION, 8);
  response := SendRequest(request, 18);
  period := LEConvertUInt32From(8, response);
  valueHasToChange := LEConvertBooleanFrom(12, response);
  option := LEConvertCharFrom(13, response);
  min := LEConvertUInt16From(14, response);
  max := LEConvertUInt16From(16, response);
end;

function TBrickletDistanceIRV2.GetAnalogValue: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_ANALOG_VALUE, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletDistanceIRV2.SetAnalogValueCallbackConfiguration(const period: longword; const valueHasToChange: boolean; const option: char; const min: longword; const max: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_ANALOG_VALUE_CALLBACK_CONFIGURATION, 22);
  LEConvertUInt32To(period, 8, request);
  LEConvertBooleanTo(valueHasToChange, 12, request);
  LEConvertCharTo(option, 13, request);
  LEConvertUInt32To(min, 14, request);
  LEConvertUInt32To(max, 18, request);
  SendRequest(request, 0);
end;

procedure TBrickletDistanceIRV2.GetAnalogValueCallbackConfiguration(out period: longword; out valueHasToChange: boolean; out option: char; out min: longword; out max: longword);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_ANALOG_VALUE_CALLBACK_CONFIGURATION, 8);
  response := SendRequest(request, 22);
  period := LEConvertUInt32From(8, response);
  valueHasToChange := LEConvertBooleanFrom(12, response);
  option := LEConvertCharFrom(13, response);
  min := LEConvertUInt32From(14, response);
  max := LEConvertUInt32From(18, response);
end;

procedure TBrickletDistanceIRV2.SetMovingAverageConfiguration(const movingAverageLength: word);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_MOVING_AVERAGE_CONFIGURATION, 10);
  LEConvertUInt16To(movingAverageLength, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDistanceIRV2.GetMovingAverageConfiguration: word;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_MOVING_AVERAGE_CONFIGURATION, 8);
  response := SendRequest(request, 10);
  result := LEConvertUInt16From(8, response);
end;

procedure TBrickletDistanceIRV2.SetDistanceLEDConfig(const config: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_DISTANCE_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDistanceIRV2.GetDistanceLEDConfig: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_DISTANCE_LED_CONFIG, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletDistanceIRV2.SetSensorType(const sensor: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_SENSOR_TYPE, 9);
  LEConvertUInt8To(sensor, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDistanceIRV2.GetSensorType: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_SENSOR_TYPE, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletDistanceIRV2.GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_SPITFP_ERROR_COUNT, 8);
  response := SendRequest(request, 24);
  errorCountAckChecksum := LEConvertUInt32From(8, response);
  errorCountMessageChecksum := LEConvertUInt32From(12, response);
  errorCountFrame := LEConvertUInt32From(16, response);
  errorCountOverflow := LEConvertUInt32From(20, response);
end;

function TBrickletDistanceIRV2.SetBootloaderMode(const mode: byte): byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_BOOTLOADER_MODE, 9);
  LEConvertUInt8To(mode, 8, request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletDistanceIRV2.GetBootloaderMode: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_BOOTLOADER_MODE, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletDistanceIRV2.SetWriteFirmwarePointer(const pointer: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER, 12);
  LEConvertUInt32To(pointer, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDistanceIRV2.WriteFirmware(const data: array of byte): byte;
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_WRITE_FIRMWARE, 72);
  if (Length(data) <> 64) then raise EInvalidParameterException.Create('Data has to be exactly 64 items long');
  for i := 0 to Length(data) - 1 do LEConvertUInt8To(data[i], 8 + (i * 1), request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletDistanceIRV2.SetStatusLEDConfig(const config: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_SET_STATUS_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDistanceIRV2.GetStatusLEDConfig: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_STATUS_LED_CONFIG, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletDistanceIRV2.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_CHIP_TEMPERATURE, 8);
  response := SendRequest(request, 10);
  result := LEConvertInt16From(8, response);
end;

procedure TBrickletDistanceIRV2.Reset;
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_RESET, 8);
  SendRequest(request, 0);
end;

procedure TBrickletDistanceIRV2.WriteUID(const uid: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_WRITE_UID, 12);
  LEConvertUInt32To(uid, 8, request);
  SendRequest(request, 0);
end;

function TBrickletDistanceIRV2.ReadUID: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_READ_UID, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletDistanceIRV2.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_DISTANCE_IR_V2_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request, 33);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

procedure TBrickletDistanceIRV2.CallbackWrapperDistance(const packet: TByteArray);
var distance: word;
begin
  if (Length(packet) <> 10) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  distance := LEConvertUInt16From(8, packet);
  if (Assigned(distanceCallback)) then begin
    distanceCallback(self, distance);
  end;
end;

procedure TBrickletDistanceIRV2.CallbackWrapperAnalogValue(const packet: TByteArray);
var analogValue: longword;
begin
  if (Length(packet) <> 12) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  analogValue := LEConvertUInt32From(8, packet);
  if (Assigned(analogValueCallback)) then begin
    analogValueCallback(self, analogValue);
  end;
end;

end.
